/*
 * md5.h - MD5 (Message Digest) stuff
 */

#ifndef PIDENTD_MD5_H
#define PIDENTD_MD5_H

#define MD5_DATASIZE    64
#define MD5_DATALEN     16
#define MD5_DIGESTSIZE  16
#define MD5_DIGESTLEN    4

struct md5_ctx {
    uint32_t digest[MD5_DIGESTLEN]; /* Digest */
    uint32_t count_l, count_h;      /* Block count */
    uint8_t block[MD5_DATASIZE];    /* One block buffer */
    int index;                      /* Index into buffer */
};

typedef struct
{
    uint8_t buf[MD5_DIGESTSIZE];
} md5_digest_t;


void md5_init(struct md5_ctx *ctx);
void md5_update(struct md5_ctx *ctx, uint8_t *buffer, uint32_t len);
void md5_final(struct md5_ctx *ctx);
void md5_digest(struct md5_ctx *ctx, uint8_t *s);
void md5_copy(struct md5_ctx *dest, struct md5_ctx *src);

int  md5_file(const char *path, md5_digest_t *md);

#endif
